# -*- coding: utf-8 -*-

# This file is part of the Gedit LaTeX Plugin
#
# Copyright (C) 2006 Michael Zeising
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public Licence as published by the Free Software
# Foundation; either version 2 of the Licence, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public Licence for more 
# details.
#
# You should have received a copy of the GNU General Public Licence along with
# this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA  02110-1301, USA

from gtk import ScrolledWindow, TextView, TextBuffer, POLICY_AUTOMATIC
from pango import FontDescription
from time import strftime

COMMAND, STDOUT, STDERR = 0, 1, 2

class ConsoleView(ScrolledWindow):
	def __init__(self):
		ScrolledWindow.__init__(self)
		
		self.__buffer = TextBuffer()
		self.__buffer.create_tag("command", foreground="darkgrey")
		self.__buffer.create_tag("stderr", foreground="darkred")
		
		self.__view = TextView(self.__buffer)
		self.__view.set_editable(False)
		self.__view.modify_font(FontDescription("Monospace"))
		
		self.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
		self.add(self.__view)
		
		self.show_all()
	
	def clear(self):
		self.__buffer.set_text("")
	
	def append(self, text, type):
		"""
		Append text to the console output
		"""
		#
		# TODO: coloring doesn't work very nice because the Builder isn't able
		# to correctly fetch from stdout and stderr
		#
		
#		iter_l = self.__buffer.get_iter_at_mark(self.__buffer.get_insert())
#		mark_l = self.__buffer.create_mark(None, iter_l, True)
#		mark_r = self.__buffer.create_mark(None, iter_l, False)
		
		self.__buffer.insert_at_cursor("[%s] %s" % (strftime("%H:%M:%S"), text))
		
#		if type == COMMAND:
#			self.__buffer.apply_tag_by_name("command", self.__buffer.get_iter_at_mark(mark_l), \
#										self.__bufferiter_at_mark(mark_r))
#		elif type == STDERR:
#			self.__buffer.apply_tag_by_name("stderr", self.__buffer.get_iter_at_mark(mark_l), \
#										self.__buffer.get_iter_at_mark(mark_r))
#		
#		self.__buffer.delete_mark(mark_l)
#		self.__buffer.delete_mark(mark_r)