# -*- coding: utf-8 -*-

# This file is part of the Gedit LaTeX Plugin
#
# Copyright (C) 2006 Michael Zeising
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public Licence as published by the Free Software
# Foundation; either version 2 of the Licence, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public Licence for more 
# details.
#
# You should have received a copy of the GNU General Public Licence along with
# this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA  02110-1301, USA

from os.path import basename

SEVERITY_ERROR, SEVERITY_WARNING = 0, 1

class Message(object):
	"""
	This encapsulates a message produced by a compiler or any build backend.
	
	It contains the filename, the line number and the message text itself.
	"""
	#
	# TODO: check and transform the provided filename
	#
	def __init__(self, filename, line, text, severity=SEVERITY_ERROR):
		self.filename = filename
		self.line = line
		self.text = text
		self.severity = severity
	
	def get_basename(self):
		return basename(self.filename)